/*  */
// ************************************************************************
// 
//                              Sundance
//                 Copyright (2005) Sandia Corporation
// 
// Copyright (year first published) Sandia Corporation.  Under the terms 
// of Contract DE-AC04-94AL85000 with Sandia Corporation, the U.S. Government 
// retains certain rights in this software.
// 
// This library is free software; you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; either version 2.1 of the
// License, or (at your option) any later version.
//  
// This library is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//                                                                                 
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
// USA                                                                                
// Questions? Contact Kevin Long (krlong@sandia.gov), 
// Sandia National Laboratories, Livermore, California, USA
// 
// ************************************************************************
/*  */

#ifndef SUNDANCEDEFAULTPATH_H
#define SUNDANCEDEFAULTPATH_H

using std::string;

namespace SundanceUtils
{
inline string defaultSundancePath()
{ 
  static string installDir = "/usr";
  static string buildDir = "/build/buildd-trilinos_10.0.4.dfsg-1.1+b1-ia64-ZPceah/trilinos-10.0.4.dfsg/obj-ia64-linux-gnu/packages/Sundance";
  static string trilinosData = "NOTFOUND";
  static string cwd = ".";

  static string sundanceEtc = buildDir + "/etc";
  static string sundanceData = buildDir + "/examples-tutorial/data";

  static string isundanceEtc = installDir + "/etc";
  static string isundanceData = installDir + "/examples-tutorial/data";

  static string sundanceMesh = trilinosData + "/Sundance/meshes";




  static string rtn = cwd + ":" + sundanceEtc + ":" + isundanceEtc 
                    + ":" + sundanceMesh 
                    + ":" + sundanceData + ":" + isundanceData ;

  return rtn;
}
}

#endif


